=== debian/changelog ===
openms (1.11.1-3) unstable; urgency=low

  * remove version number from libbost development package names;
  * ensure that AUTHORS is correctly shipped in all packages.
  
 -- Filippo Rusconi <lopippo@debian.org>  Fri, 20 Dec 2013 11:30:16 +0100

openms (1.11.1-2) unstable; urgency=low

  * New upstream release.

  * debian/control: canonicalize the Vcs-Git and Vcs-Browser fields;
  
  * debian/control: remove the Conflicts declaration for -dev, which is not
    required at all;
  
  * add *.desktop files to reference OpenMS in the non-Debian menus
    (thanks to Olivier Langella). Note that preexisting topp.menu shows
    the menus in the Debian menu if menu-xdg is installed. Sent enquiry
    about having these two files included in upstream.
  
  * Standards-Version: 3.9.4;
    
 -- Filippo Rusconi <lopippo@debian.org>  Thu, 19 Dec 2013 09:41:22 +0100

openms (1.11.0-1) UNRELEASED; urgency=low

  * New upstream release.

 -- Filippo Rusconi <lopippo@debian.org>  Wed, 10 Jul 2013 22:54:41 +0200

openms (1.10.0-1) UNRELEASED; urgency=low

  * New upstream release.

 -- Filippo Rusconi <lopippo@debian.org>  Wed, 10 Jul 2013 22:54:41 +0200
