=== debian/watch ===
version=3

http://sf.net/open-ms/OpenMS-([\d\.]+)\.tar\..*
